import { RpsContext } from 'rpscript-interface';
/** Module for parsing CSV file
 * @see {@link https://www.npmjs.com/package/csv|CSV}
 * @namespace CSV
 * @example
 * rps install csv
*/
export default class RPSCsv {
    /**
     * @function csv-to-data
     * @memberof CSV
     * @param {string} csvString csv content to be parsed
     * @example
     * csv-to-data --columns=true read-file "input.csv"
     *
     *
     * @summary csv-to-data :: String → String
     *
     * @description
     * For the list of parsing options:
     * @see {@link http://csv.adaltas.com/parse/}
    */
    parseCsvToData(ctx: RpsContext, opts: Object, csvString?: string): Promise<any>;
    /**
     * @function data-to-csv
     * @memberof CSV
     * @param {string} data csv content to be parsed
     * @example
     * write-file "result.csv" data-to-csv $processedResult
     *
     * @summary data-to-csv :: String → String
     *
     * @description
     * For the list of parsing options:
     * @see {@link http://csv.adaltas.com/stringify/}
     *
    */
    parseDataToCsv(ctx: RpsContext, opts: Object, data?: any): Promise<any>;
}
