"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const sync_1 = __importDefault(require("csv-parse/lib/sync"));
const sync_2 = __importDefault(require("csv-stringify/lib/sync"));
const rpscript_interface_1 = require("rpscript-interface");
/** Module for parsing CSV file
 * @see {@link https://www.npmjs.com/package/csv|CSV}
 * @namespace CSV
 * @example
 * rps install csv
*/
let RPSCsv = class RPSCsv {
    /**
     * @function csv-to-data
     * @memberof CSV
     * @param {string} csvString csv content to be parsed
     * @example
     * csv-to-data --columns=true read-file "input.csv"
     *
     *
     * @summary csv-to-data :: String → String
     *
     * @description
     * For the list of parsing options:
     * @see {@link http://csv.adaltas.com/parse/}
    */
    parseCsvToData(ctx, opts, csvString) {
        return __awaiter(this, void 0, void 0, function* () {
            if (csvString)
                return sync_1.default(csvString, opts);
            else
                return function (csvString) { return sync_1.default(csvString, opts); };
        });
    }
    /**
     * @function data-to-csv
     * @memberof CSV
     * @param {string} data csv content to be parsed
     * @example
     * write-file "result.csv" data-to-csv $processedResult
     *
     * @summary data-to-csv :: String → String
     *
     * @description
     * For the list of parsing options:
     * @see {@link http://csv.adaltas.com/stringify/}
     *
    */
    parseDataToCsv(ctx, opts, data) {
        return __awaiter(this, void 0, void 0, function* () {
            if (data)
                return sync_2.default(data, opts);
            else
                return function (data) { return sync_2.default(data, opts); };
        });
    }
};
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'csv-to-data' })
], RPSCsv.prototype, "parseCsvToData", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'data-to-csv' })
], RPSCsv.prototype, "parseDataToCsv", null);
RPSCsv = __decorate([
    rpscript_interface_1.RpsModule("csv")
], RPSCsv);
exports.default = RPSCsv;
